
Library PPKdlv02; 

{This is the DLL reduced to a single, functioning call. All calls function 
 in almost the exact same method and each will independently attempt all 
 memory initialization.}

uses WINTYPES,WINPROCS,STRINGS,
     TypeUnit,MiscUnit,PPKTypes,PPKNotaU,PPKSortU;

function ACTInitHdlsPtrs(var MemHdl:THandle):Boolean;

var
   N		      : integer;
   MemLocPtr	: MemLocPtrTyp;
begin
   ACTInitHdlsPtrs:=false;
   MemHdl:=GlobalAlloc(gmem_Moveable,sizeOf(RunInfoRec));
   if MemHdl=0 then EXIT;
   RI:=GlobalLock(MemHdl);
   if RI=nil then EXIT;
   FillChar(RI^,sizeOf(RunInfoRec),#0);
   LoadBinData;
   if RI^.Abort666<>0 then EXIT;
   InitTransforms;
   if RI^.Abort666<>0 then EXIT;
   if GlobalUnlock(MemHdl) then EXIT; {True if lock still remains (bad)}
   ACTInitHdlsPtrs:=True;
end;

FUNCTION UNPKNOTATION_BB(VAR MEMHDL:THANDLE;PC2,PC:PChar):LONGBOOL;EXPORT;
label 999;
var
   N	: integer;
begin
   UNPKNOTATION_BB:=FALSE;
   if MemHdl=0 then
      if not ACTInitHdlsPtrs(MemHdl) then
         if RI^.Abort666<>0 then {RI still locked if this happens}
            begin
               StrPCopy(PC2,RI^.LogicErr);
               goto 999;
            end
         else
            begin
               StrPCopy(PC2,'memory error');
               goto 999;
            end;
   RI:=GlobalLock(MemHdl);
   if RI=nil then EXIT;
   with RI^ do
   	begin
         UnPackNotation(PC2,PC);
         if Abort666<>0 then
            begin
               StrPCopy(PC2,LogicErr);
               goto 999;
            end;
      end;
   UNPKNOTATION_BB:=TRUE;
999:
   if GlobalUnlock(MemHdl) then EXIT; {True if lock still remains}
end;

FUNCTION DESTROY(VAR MEMHDL:THANDLE):LONGBOOL;EXPORT;
VAR
   MemLocPtr	: MemLocPtrTyp;
BEGIN
   Destroy:=false;
   RI:=GlobalLock(MemHdl);
   if RI=nil then EXIT;
   with RI^ do
   begin
      DestroyBinData;
      if GlobalFree(MemHdl)<>0 then EXIT;
      MemHdl:=0;
   end;
   Destroy:=True;
END;

EXPORTS
   UNPKNOTATION_BB    INDEX 2,
   DESTROY            INDEX 99;
BEGIN
END.
